<template>
  <div class="q-pa-md">
    <q-file
      filled
      bottom-slots
      v-model="newUpload"
      label="Neues Modell hochladen"
      counter
      accept=".onnx, .zip"
      color="grey-11"
      label-color="grey-11"
      bg-color="positive"
    >
      <template v-slot:prepend>
        <q-icon name="cloud_upload" @click.stop.prevent color="grey-11" />
      </template>
      <template v-slot:append>
        <q-btn
          icon="close"
          color="negative"
          hint=""
          @click.stop.prevent="newUpload = null"
          class="cursor-pointer"
        />
        <q-btn
          @click.stop.prevent="upload"
          color="primary"
          icon-right="send"
          label="hochladen"
          :disable="newUpload === null"
        />
      </template>

      <template v-slot:hint>
        <b>Überschreibt vorhandene Dateien mit dem selben Namen!</b>
        .zip oder .onnx. Falls ein zip verwendet wird, so muss dieses die
        Konfiguration `config.py` mit den nötigen Parametern auf oberster
        Ebene (nicht in einem Ordner) enthalten.
      </template>
    </q-file>
    <p></p>

    <div class="row justify-center">
      <div class="col">
        <div class="q-pa-md row items-start q-gutter-md">
          <ModelDisplay
            v-for="folder in modelFolders"
            :folder="folder"
            :key="folder.path"
            :active="(folder.path == serviceStatus?.current_selected_model)"
          ></ModelDisplay>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, toRefs, onMounted } from 'vue';
import { useQuasar } from 'quasar';
import { useApiStore } from 'stores/api-store';
import ModelDisplay from 'components/model-manager/ModelDisplay.vue';

const $q = useQuasar();

const newUpload = ref<File|null>(null);

const apiStore = useApiStore();

const { modelFolders, serviceStatus } = toRefs(apiStore.$state);

const refresh = async () => {
  await apiStore.updateModelFolderList();
};
const upload = async () => {
  if (newUpload.value) {
    $q.loading.show({
      delay: 200, // ms
    });
    try {
      await apiStore.uploadNewModel(newUpload.value);
      newUpload.value = null;
      await refresh();
      $q.notify({
        message: 'Successfully uploaded',
        multiLine: true,
        type: 'positive',
      });
    } catch {
      // do nothing
    } finally {
      $q.loading.hide();
    }
  }
};
onMounted(async () => {
  await refresh();
});
</script>
